package actions;

import java.util.List;
import java.util.Map;

import org.apache.struts2.interceptor.SessionAware;

import model.service.Cistell;
import model.service.CistellProducte;
import model.service.ClientContainer;
import model.service.ProducteService;
import model.service.ProducteServiceImpl;
import model.vo.Vi;

import com.opensymphony.xwork2.ActionSupport;

public class CistellAction extends ActionSupport implements SessionAware {

	private static final long serialVersionUID = 3761792989546996118L;

	@SuppressWarnings("unchecked")
	private Map session;
	private ClientContainer clientcontainer;
	private Cistell cistell = new Cistell();
	private CistellProducte cistellproducte;
	private List<CistellProducte> productesList;
	private int id;
	private int QUANTITAT;
	private Vi producte;
	private ProducteService viService = new ProducteServiceImpl();
	
	public CistellAction() {
	}
	
	public String execute() {
		// Recuperem dades del cistell de la sesi d'usuari
		setClientcontainer((ClientContainer) session.get("ClientContainer"));
		if (clientcontainer!=null) {
			setCistell(clientcontainer.getCistell());
			productesList = cistell.getProductos();
			return SUCCESS;
		}
		else return "error";
	}

	@SuppressWarnings("unchecked")
	public String addVi() {
		if(QUANTITAT>0 && QUANTITAT<25) {
			// Recuperem dades del cistell de la sesi d'usuari
			setClientcontainer((ClientContainer) session.get("ClientContainer"));
			if (clientcontainer!=null) {
				producte = viService.getVi(getId());
				// Afegim el producte i la quantitat al cistell
				cistellproducte = new CistellProducte(producte, QUANTITAT);
				setCistell(clientcontainer.getCistell());
				cistell.addProducto(cistellproducte);
				// Afegim el cistell al contenidor de la sesi d'usuari
				clientcontainer.setCistell(cistell);
				session.put("sizeCistell", cistell.getSize());
				session.put("totalPrice", cistell.getTotalPrice());
				session.put("ClientContainer", clientcontainer);
				return SUCCESS;			
			}
			else return "error";
		}
		return "input";
	}

	@SuppressWarnings("unchecked")
	public String buidar() {
		// Recuperem dades del cistell de la sesi d'usuari
		setClientcontainer((ClientContainer) session.get("ClientContainer"));
		if (clientcontainer!=null) {
			setCistell(clientcontainer.getCistell());
			// Buidem el cistell d'usuari
			cistell.empty();
			// Afegim el cistell al contenidor de la sesi d'usuari
			clientcontainer.setCistell(cistell);
			session.put("sizeCistell", cistell.getSize());
			session.put("totalPrice", cistell.getTotalPrice());
			session.put("ClientContainer", clientcontainer);			
			return SUCCESS;			
		}
		else return "error";
	}
	
	@SuppressWarnings("unchecked")
	public String esborra() {
		// Recuperem dades del cistell de la sesi d'usuari
		setClientcontainer((ClientContainer) session.get("ClientContainer"));
		if (clientcontainer!=null) {
			producte = viService.getVi(getId());
			setCistell(clientcontainer.getCistell());
			cistell.removeProducte(Integer.toString(producte.getId()));
			// Afegim el cistell al contenidor de la sesi d'usuari
			clientcontainer.setCistell(cistell);
			session.put("sizeCistell", cistell.getSize());
			session.put("totalPrice", cistell.getTotalPrice());
			session.put("ClientContainer", clientcontainer);
			return SUCCESS;
		}
		else return "error";
	}
	
	public void setQUANTITAT(int qUANTITAT) {
		QUANTITAT = qUANTITAT;
	}

	public int getQUANTITAT() {
		return QUANTITAT;
	}

	public void setProducte(Vi producte) {
		this.producte = producte;
	}

	public Vi getProducte() {
		return producte;
	}

	public void setId(int id) {
		this.id = id;
	}

	public int getId() {
		return id;
	}

	@SuppressWarnings("unchecked")
	public void setSession(Map session) {
		this.session = session;
	}

	public void setClientcontainer(ClientContainer clientcontainer) {
		this.clientcontainer = clientcontainer;
	}

	public ClientContainer getClientcontainer() {
		return clientcontainer;
	}

	public void setCistell(Cistell cistell) {
		this.cistell = cistell;
	}

	public Cistell getCistell() {
		return cistell;
	}

	public void setCistellproducte(CistellProducte cistellproducte) {
		this.cistellproducte = cistellproducte;
	}

	public CistellProducte getCistellproducte() {
		return cistellproducte;
	}
	
	public List<CistellProducte> getProductesList() {
		return productesList;
	}

	public void setProductesList(List<CistellProducte> productesList) {
		this.productesList = productesList;
	}
	
}
