package actions;

import java.util.List;
import java.util.Map;

import org.apache.struts2.interceptor.SessionAware;
import org.hibernate.exception.ConstraintViolationException;

import model.service.ClientService;
import model.service.ClientServiceImpl;
import model.service.ProvinciaService;
import model.service.ProvinciaServiceImpl;
import model.vo.Client;
import model.vo.Provincia;

import com.opensymphony.xwork2.ActionSupport;

public class ClientAction extends ActionSupport implements SessionAware {

	private static final long serialVersionUID = 1794684011021565186L;

	@SuppressWarnings("unchecked")
	private Map session;
	private String USERNAME = null;
	private String DADA, acotacio;
	private Client client;
	private List<Client> clientList;
    private List<Provincia> provinciaList;
	private ClientService clientService = new ClientServiceImpl();
    private ProvinciaService proService = new ProvinciaServiceImpl();

	public ClientAction() {
		
	}

	// Comprova que hi ha usuari autenticat 
	public String execute() {
    	if(session.get("username")!=null)
        	return "admin";
        else return SUCCESS;
	}
	
    @SuppressWarnings("unchecked")
	public String prep() {
        this.setProvinciaList(proService.list());
		session.put("provincies", provinciaList);
        return SUCCESS;
    }
	
    // Carrega les dades d'un usuari
	public String loadDades() {
		try {
			prep();
			USERNAME = session.get("username").toString();
			client = clientService.loadClient(USERNAME);
			return SUCCESS;
		} catch (Exception e) {
			return "error";
		}
	}

	// Mostra una llista de tots els clients
	public String list() {
        this.setClientList(clientService.getAllClients()); 
        return SUCCESS;
    }

	// Mostra les dades d'un usuari
	@SuppressWarnings("unchecked")
	public String show() {
    	prep();
		session.put("admin", USERNAME);
    	client = clientService.loadClient(getUSERNAME());
    	return SUCCESS;
    }

	public String esborrar() {
		try {
			clientService.deleteClient(USERNAME);
			return SUCCESS;
		} catch (ConstraintViolationException e) {
    		addActionError("No es possible esborrar el client, ha realitzat comandes.");
			return INPUT;			
		}
	}

	public String recerca() {
		if(acotacio.equals("1"))
			this.setClientList(clientService.getClientByNom(DADA));
		else if (acotacio.equals("2"))
			this.setClientList(clientService.getClientByCognom1(DADA));
		else if (acotacio.equals("3"))
			this.setClientList(clientService.getClientByCognom2(DADA));
		return SUCCESS;
	}
	
    public String getAcotacio() {
		return acotacio;
	}

	public void setAcotacio(String acotacio) {
		this.acotacio = acotacio;
	}

	public String getDADA() {
		return DADA;
	}

	public void setDADA(String DADA) {
		this.DADA = DADA;
	}

	public void setCliService(ClientService clientService) {
		this.clientService = clientService;
	}

	public ClientService getClientService() {
		return clientService;
	}

	public void setClient(Client client) {
		this.client = client;
	}

	public Client getClient() {
		return client;
	}
	
	public String getUSERNAME() {
		return USERNAME;
	}

	public void setUSERNAME(String USERNAME) {
		this.USERNAME = USERNAME;
	}

	public void setClientList(List<Client> clientList) {
		this.clientList = clientList;
	}

	public List<Client> getClientList() {
		return clientList;
	}

	public void setProvinciaList(List<Provincia> provinciaList) {
		this.provinciaList = provinciaList;
	}

	public List<Provincia> getProvinciaList() {
		return provinciaList;
	}
	
	public void setProService(ProvinciaService proService) {
		this.proService = proService;
	}

	public ProvinciaService getProService() {
		return proService;
	}

	@SuppressWarnings("unchecked")
	public void setSession(Map session) {
		this.session = session;
	}
}
