package actions;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Map;

import model.service.Cistell;
import model.service.CistellProducte;
import model.service.ClientContainer;
import model.service.ClientService;
import model.service.ClientServiceImpl;
import model.service.ComandaService;
import model.service.ComandaServiceImpl;
import model.vo.Client;
import model.vo.Comanda;
import model.vo.LineaComanda;

import org.apache.struts2.interceptor.SessionAware;

import com.opensymphony.xwork2.ActionSupport;

public class ComandaAction extends ActionSupport implements SessionAware {

	private static final long serialVersionUID = -4045884834142112403L;
	
	@SuppressWarnings("unchecked")
	private Map session;
	private int id, i;
	private String username;
	private ClientContainer clientcontainer;
	private Cistell cistell = new Cistell();
	private CistellProducte cistellproducte;
	private Client client;
	private Date data;
	private float total;
	private Comanda comanda = new Comanda();
	private LineaComanda linea;
	private List<Comanda> comandaList;
	private List<LineaComanda> lineaList = new ArrayList<LineaComanda>();
	private List<CistellProducte> producteList;
	private ClientService cliService = new ClientServiceImpl();
	private ComandaService coService = new ComandaServiceImpl();
	
	public ComandaAction() {
	}

    public String execute() {
    	if(session.get("username")!=null)
        	return "admin";
    	else 
    		return SUCCESS;
    }
    
	public String addComanda() {
		try {
			// Recuperem dades del cistell de la sesi d'usuari
			setClientcontainer((ClientContainer) session.get("ClientContainer"));
			if (clientcontainer!=null) {
				username = (String) session.get("username");
				// Recuperem les dades de client
				client = cliService.loadClient(username);
				Calendar cal = Calendar.getInstance();
				// Fixem la data actual del sistema
				data = cal.getTime();
				cistell = clientcontainer.getCistell();
				// Acabem si el cistell es buit
				if (cistell.getSize()==0) {
					addActionError("No hi ha productes al cistell de compra.");
					return "error";
				}
				// Recuperem l'import total del cistell
				total = cistell.getTotalPrice();
				// Agrupem les dades de la comanda
				comanda.setCLIENT(client);
				comanda.setDATA(data);
				comanda.setIMPORT_TOTAL(total);
				// Agrupem les linees de la comanda
				producteList = cistell.getProductos();
				for(i=0;i<cistell.getSize();i++) {
					cistellproducte = producteList.get(i);
					linea = new LineaComanda(i, comanda, cistellproducte.getNOM(), 
							cistellproducte.getImporte(), cistellproducte.getQuantity());
					lineaList.add(linea);
				}
				// Afegim les linees i la comanda
				coService.addComanda(comanda, lineaList);
			}
		} catch (Exception e) {
			addActionError("No ha estat possible emmagatzemar la comanda.");
			return "error";
		}
		return SUCCESS;
	}
	
	public String list() {
		comandaList = coService.getAllComandes();
		return SUCCESS;
	}
	
	public String listByClient() {
		try {
			username = (String) session.get("username");
			if (username=="admin") {
				list();
				return "admin";
			} else if (username!=null) {
				this.comandaList = coService.getComandesByClient(username);
				return "client";
			} else	
				return SUCCESS;
		} catch (Exception e) {
        	return SUCCESS;
		}
	}
	
	public String show() {
		comanda = coService.loadComanda(getId());
		lineaList = coService.loadLineaComanda(comanda);
        if (session.get("username")=="admin")
        	return "admin";
        else if (session.get("username")!=null)
        	return "client";
        else
        	return "error";
	}

	public String recerca() {
		if (session.get("username")!=null){
			comanda = coService.loadComanda(id);
			lineaList = coService.loadLineaComanda(comanda);			
			if (comanda!=null)
				return SUCCESS;
			else {
				addActionError("Aquesta comanda no existeix al sistema!");
				return "input";
			}
		} else return "error";
	}
	
	@SuppressWarnings("unchecked")
	public void setSession(Map session) {
		this.session = session;	
	}

	public void setClient(Client client) {
		this.client = client;
	}

	public Client getClient() {
		return client;
	}

	public void setData(Date data) {
		this.data = data;
	}

	public Date getData() {
		return data;
	}

	public void setCoService(ComandaService coService) {
		this.coService = coService;
	}

	public ComandaService getCoService() {
		return coService;
	}

	public void setUsername(String username) {
		this.username = username;
	}

	public String getUsername() {
		return username;
	}

	public void setClientcontainer(ClientContainer clientcontainer) {
		this.clientcontainer = clientcontainer;
	}

	public ClientContainer getClientcontainer() {
		return clientcontainer;
	}

	public void setCistell(Cistell cistell) {
		this.cistell = cistell;
	}

	public Cistell getCistell() {
		return cistell;
	}

	public void setCistellproducte(CistellProducte cistellproducte) {
		this.cistellproducte = cistellproducte;
	}

	public CistellProducte getCistellproducte() {
		return cistellproducte;
	}

	public void setTotal(float total) {
		this.total = total;
	}

	public float getTotal() {
		return total;
	}

	public void setComanda(Comanda comanda) {
		this.comanda = comanda;
	}

	public Comanda getComanda() {
		return comanda;
	}

	public void setComandaList(List<Comanda> comandaList) {
		this.comandaList = comandaList;
	}

	public List<Comanda> getComandaList() {
		return comandaList;
	}

	public void setId(int id) {
		this.id = id;
	}

	public int getId() {
		return id;
	}

	public void setProducteList(List<CistellProducte> producteList) {
		this.producteList = producteList;
	}

	public List<CistellProducte> getProducteList() {
		return producteList;
	}

	public void setLinea(LineaComanda linea) {
		this.linea = linea;
	}

	public LineaComanda getLinea() {
		return linea;
	}

	public void setLineaList(List<LineaComanda> lineaList) {
		this.lineaList = lineaList;
	}

	public List<LineaComanda> getLineaList() {
		return lineaList;
	}
	
	
}
