package actions;

import java.util.List;
import java.util.Map;

import org.apache.struts2.interceptor.SessionAware;
import org.hibernate.exception.ConstraintViolationException;

import com.opensymphony.xwork2.ActionSupport;

import model.service.ProducteService;
import model.service.ProducteServiceImpl;
import model.vo.Denominacio;

public class DenominacioAction extends ActionSupport implements SessionAware {

	private static final long serialVersionUID = 675057494253793263L;
	
	@SuppressWarnings("unchecked")
	private Map session;
	private int id;
	private Denominacio denominacio = null;
	private List<Denominacio> denominacioList;
	
	private ProducteService denominacioService = new ProducteServiceImpl();

    public DenominacioAction() {
    	
	}

	public String list() {
        this.denominacioList = denominacioService.list();
        // Comprovar que l'usuari no s visitant o administrador
        if(session.get("username")!=null && !session.get("username").equals("admin"))
        	return "client";
        else 
        	return SUCCESS;
    }
    
    public String show() {
    	denominacio = denominacioService.loadDenominacio(getId());
        this.denominacioList = denominacioService.list();
        if(session.get("username")!=null)
        	return "client";
        else 
        	return SUCCESS;
    }

    public String esborrar() {
    	try {
    		denominacioService.deleteDenominacio(getId());
    		return SUCCESS;
    	} catch (ConstraintViolationException e){
    		denominacio = denominacioService.loadDenominacio(id); 
    		addActionError("La denominaci " + denominacio.getNOM() +
    				" no es pot esborrar, t vins associats.");
    		return INPUT;
    	}
    }
    
    public void setDenominacioList(List<Denominacio> denominacioList) {
		this.denominacioList = denominacioList;
	}

	public List<Denominacio> getDenominacioList() {
		return denominacioList;
	}

	public ProducteService getDenominacioService() {
		return denominacioService;
	}

	public void setDenominacioService(ProducteService denominacioService) {
		this.denominacioService = denominacioService;
	}

	public void setDenominacio(Denominacio denominacio) {
		this.denominacio = denominacio;
	}

	public Denominacio getDenominacio() {
		return denominacio;
	}

	public void setId(int id) {
		this.id = id;
	}

	public int getId() {
		return id;
	}

	@SuppressWarnings("unchecked")
	public void setSession(Map session) {
		this.session = session;
	}
	
}
