package actions;

import java.util.Map;

import org.apache.struts2.interceptor.SessionAware;
import org.apache.struts2.interceptor.validation.SkipValidation;
import org.hibernate.exception.ConstraintViolationException;

import model.service.ClientService;
import model.service.ClientServiceImpl;
import model.vo.Client;

import com.opensymphony.xwork2.ActionSupport;

public class RegistreAction extends ActionSupport implements SessionAware {

	private static final long serialVersionUID = 1005942784459246980L;
	
	private String USERNAME;
	private String PASSWORD;
	private String NOM;
	private String COGNOM1;
	private String COGNOM2;
	private String EMAIL;
	private String DIRECCIO;
	private String CODIPOSTAL;
	private String POBLACIO;
	
	@SuppressWarnings("unchecked")
	private Map session;
	private Client client;
	private ClientService cService = new ClientServiceImpl();

	public RegistreAction() {
	}

	public String add() { 
    	try {
    		client.setUSERNAME(USERNAME);
        	client.setPASSWORD(PASSWORD);
        	client.setNOM(NOM);
        	client.setCOGNOM1(COGNOM1);
        	client.setCOGNOM2(COGNOM2);
        	client.setDIREC(DIRECCIO);
        	client.setPOBLACIO(POBLACIO);
        	client.setCODI_POSTAL(CODIPOSTAL);
        	client.setEMAIL(EMAIL);
            cService.insertClient(client);
    		return SUCCESS;
    	} catch (ConstraintViolationException e) {
    		addActionError("No es possible registrar el client, ja existeix l'usuari al sistema!");
    		return INPUT;
    	}
    }

	@SkipValidation 
	public String update() {
		try {
			if(session.get("username").toString()!="admin")
					//Si la sesi s de usuari
				USERNAME = session.get("username").toString();
			else
					//Si la sesi s d'administrador
				USERNAME = session.get("admin").toString();
			if(cService.loadClient(USERNAME) != null) {
				client.setUSERNAME(USERNAME);
	    		client.setPASSWORD(PASSWORD);
	    		client.setNOM(NOM);
	    		client.setCOGNOM1(COGNOM1);
	    		client.setCOGNOM2(COGNOM2);
	    		client.setDIREC(DIRECCIO);
	    		client.setPOBLACIO(POBLACIO);
	    		client.setCODI_POSTAL(CODIPOSTAL);
	    		client.setEMAIL(EMAIL);    	
	    		cService.updateClient(client);        	
	    		if(session.get("username")!="admin")
	    			return SUCCESS;
	    		else return "admin";
	        } else {
	        	addActionError("No ha estat possible realitzar la modificaci de l'usuari al sistema!");
	        	if(session.get("username")!="admin")
	        		return INPUT;
	        	else return "admin";
	        }
		} catch (Exception e) {
				// Si la sesi ha caducat
			return "error";
		}
	}
	
    public Client getClient() {
		return client;
	}

	public void setClient(Client client) {
		this.client = client;
	}

	public void setUSERNAME(String uSERNAME) {
		USERNAME = uSERNAME;
	}

	public String getUSERNAME() {
		return USERNAME;
	}

	public void setPASSWORD(String pASSWORD) {
		PASSWORD = pASSWORD;
	}

	public String getPASSWORD() {
		return PASSWORD;
	}

	public void setNOM(String nOM) {
		NOM = nOM;
	}

	public String getNOM() {
		return NOM;
	}

	public void setCOGNOM1(String cOGNOM1) {
		COGNOM1 = cOGNOM1;
	}

	public String getCOGNOM1() {
		return COGNOM1;
	}

	public void setCOGNOM2(String cOGNOM2) {
		COGNOM2 = cOGNOM2;
	}

	public String getCOGNOM2() {
		return COGNOM2;
	}

	public void setEMAIL(String eMAIL) {
		EMAIL = eMAIL;
	}

	public String getEMAIL() {
		return EMAIL;
	}

	public void setDIRECCIO(String dIRECCIO) {
		DIRECCIO = dIRECCIO;
	}

	public String getDIRECCIO() {
		return DIRECCIO;
	}

	public void setCODIPOSTAL(String cODIPOSTAL) {
		CODIPOSTAL = cODIPOSTAL;
	}

	public String getCODIPOSTAL() {
		return CODIPOSTAL;
	}

	public void setPOBLACIO(String pOBLACIO) {
		POBLACIO = pOBLACIO;
	}

	public String getPOBLACIO() {
		return POBLACIO;
	}

	@SuppressWarnings("unchecked")
	public void setSession(Map session) {
		this.session = session;
	}
}
