package actions;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.apache.struts2.interceptor.SessionAware;
import org.hibernate.exception.ConstraintViolationException;

import model.service.ProducteService;
import model.service.ProducteServiceImpl;
import model.vo.Categoria;
import model.vo.Denominacio;
import model.vo.Tipus;
import model.vo.Vi;

import com.opensymphony.xwork2.ActionSupport;

public class ViAction extends ActionSupport implements SessionAware {

	private static final long serialVersionUID = 4514243419486691823L;
	
	@SuppressWarnings("unchecked")
	private Map session;
	private int id;
	private Vi vi;
	private String find, tipus, categoria;
	private boolean description;
	private String DADA, acotacio;
	private Denominacio denominacio;
	private List<Vi> viList;
	private ArrayList<Tipus> tipusList;
	private ArrayList<Categoria> categoriaList;
	private List<Denominacio> denominacioList;
	private ProducteService viService = new ProducteServiceImpl();
	
    public ViAction() {
    	
	}

    public String execute() {
    	if(session.get("username")!=null)
        	return "client";
        else return SUCCESS;
    }
    
    // Inicialitza els arrays de l'usuari identificat
    @SuppressWarnings("unchecked")
	public String prep() {
    	// Comprova que hi ha usuari autenticat
    	if(session.get("username")!=null)
        {
        	// Array de denominacions d'origen
           	this.setDenominacioList(viService.list());
           	session.put("denominacions", denominacioList);   	
           	// Array de tipus de vi
           	tipusList = new ArrayList<Tipus>();
           	tipusList.add(new Tipus("Negre"));
           	tipusList.add(new Tipus("Rosat"));
           	tipusList.add(new Tipus("Blanc"));
           	tipusList.add(new Tipus("Espums"));
           	session.put("tipus", tipusList);
           	// Array de categoria de vi
           	categoriaList = new ArrayList<Categoria>();
           	categoriaList.add(new Categoria("Jove"));
           	categoriaList.add(new Categoria("Criana"));
           	categoriaList.add(new Categoria("Reserva"));
           	categoriaList.add(new Categoria("Gran reserva"));
           	session.put("categoria", categoriaList);
           	return SUCCESS;
        } else return "error";
    }

    //Mostra una llista dels vins d'una denominaci concreta
	public String listByDenominacio() {
        this.viList = viService.getVinsByDenominacio(getId());
        denominacio = viService.loadDenominacio(getId());
        if(session.get("username")!=null)
        	return "client";
        else 
        	return SUCCESS;
    }

    // Mostra una llista amb tots els vins
	public String list() {
        this.setViList(viService.getAllVins()); 
        return SUCCESS;
    }
    
    // Mostra les caracterstiques d'un vi
	public String show() {
    	prep();
    	vi = viService.getVi(getId());
    	denominacio = viService.loadDenominacio(vi.DENOMINACIO.getId());
        if (session.get("username")!=null)
        	return "client";
        else 
        	return SUCCESS;
    }
 
	public String esborrar() {
		try {
			viService.deleteVi(getId());
			return SUCCESS;
		} catch (ConstraintViolationException e) {
    		addActionError("No ha estat possible d'esborrar el vi.");
			return INPUT;			
		}
	}
    
    public String recerca() {
    	if(acotacio.equals("1"))
			this.setViList(viService.getVinsByNom(DADA));
		else if (acotacio.equals("2"))
			this.setViList(viService.getVinsByTipus(DADA));
		else if (acotacio.equals("3"))
			this.setViList(viService.getVinsByCategoria(DADA));
		return SUCCESS;
    }

    public String recercaText() {
    	this.setViList(viService.getVinsByNom(DADA));
    	if(session.get("username")!=null)
        	return "client";
        else 
        	return SUCCESS;
    }
    
    public String recercaAmpliada() {
    	this.setViList(viService.getVinsByCriteria(find, 
    			tipus, categoria, description));
    	if(session.get("username")!=null)
    		return "client";
    	else
    		return SUCCESS;
    }
    
	public boolean isDescription() {
		return description;
	}

	public void setDescription(boolean description) {
		this.description = description;
	}

	public String getAcotacio() {
		return acotacio;
	}

	public void setAcotacio(String acotacio) {
		this.acotacio = acotacio;
	}

	public void setViList(List<Vi> viList) {
		this.viList = viList;
	}
	
	public List<Vi> getViList() {
		return viList;
	}
	
	public void setId(int id) {
		this.id = id;
	}
	
	public int getId() {
		return id;
	}
	
	public void setViService(ProducteService viService) {
		this.viService = viService;
	}
	
	public ProducteService getViService() {
		return viService;
	}
	
	public void setDenominacioList(List<Denominacio> denominacioList) {
		this.denominacioList = denominacioList;
	}
	
	public List<Denominacio> getDenominacioList() {
		return denominacioList;
	}

	public void setTipusList(ArrayList<Tipus> tipusList) {
		this.tipusList = tipusList;
	}

	public ArrayList<Tipus> getTipusList() {
		return tipusList;
	}

	public void setCategoriaList(ArrayList<Categoria> categoriaList) {
		this.categoriaList = categoriaList;
	}

	public ArrayList<Categoria> getCategoriaList() {
		return categoriaList;
	}

	public void setVi(Vi vi) {
		this.vi = vi;
	}

	public Vi getVi() {
		return vi;
	}

	public void setDenominacio(Denominacio denominacio) {
		this.denominacio = denominacio;
	}

	public Denominacio getDenominacio() {
		return denominacio;
	}

	public void setDADA(String dADA) {
		DADA = dADA;
	}

	public String getDADA() {
		return DADA;
	}

	@SuppressWarnings("unchecked")
	public void setSession(Map session) {
		this.session = session;
	}

	public String getFind() {
		return find;
	}

	public void setFind(String find) {
		this.find = find;
	}

	public void setTipus(String tipus) {
		this.tipus = tipus;
	}

	public String getTipus() {
		return tipus;
	}

	public void setCategoria(String categoria) {
		this.categoria = categoria;
	}

	public String getCategoria() {
		return categoria;
	}

	
}
