package actions;

import org.hibernate.exception.ConstraintViolationException;

import model.service.ProducteService;
import model.service.ProducteServiceImpl;
import model.vo.Denominacio;

import com.opensymphony.xwork2.ActionSupport;

public class addDenominacio extends ActionSupport {

	private static final long serialVersionUID = -289704948660419520L;

	private int id;
	private String NOM;
	private String DESCRIPCIO;
	private Denominacio denominacio;
	private ProducteService denService = new ProducteServiceImpl();;
	
	public addDenominacio() {
	}

	public String add() throws Exception {
		try {
			Denominacio denominacio = new Denominacio();
			denominacio.setNOM(NOM);
			denominacio.setDESCRIPCIO(DESCRIPCIO);
			denService.insertDenominacio(denominacio);
			return SUCCESS;
		} catch (ConstraintViolationException e){
			addActionError("Aquesta denominaci no es pot afegir, ja es troba dins el sistema.");
			return INPUT;
		}
	}
	
    public String update() throws Exception {
    	try {
    		if(denService.loadDenominacio(id) != null) {
    			denominacio = denService.loadDenominacio(id);
    			denominacio.setNOM(NOM);
    			denominacio.setDESCRIPCIO(DESCRIPCIO);
    			denService.updateDenominacio(denominacio);
    	    }
    	} catch (Exception e) {
			addActionError("No ha estat possible realitzar la modificaci.");
			return INPUT;
    	}
    	return SUCCESS;
    }
	
	public void setNOM(String NOM) {
		this.NOM = NOM;
	}

	public String getNOM() {
		return NOM;
	}

	public String getDESCRIPCIO() {
		return DESCRIPCIO;
	}

	public void setDESCRIPCIO(String DESCRIPCIO) {
		this.DESCRIPCIO = DESCRIPCIO;
	}

	public void setDenService(ProducteService denService) {
		this.denService = denService;
	}

	public ProducteService getDenService() {
		return denService;
	}

	public void setId(int id) {
		this.id = id;
	}

	public int getId() {
		return id;
	}
}
