package actions;

import org.hibernate.exception.ConstraintViolationException;

import model.service.ProducteService;
import model.service.ProducteServiceImpl;
import model.vo.Vi;

import com.opensymphony.xwork2.ActionSupport;

public class addVi extends ActionSupport {

	private static final long serialVersionUID = -8473592519798932094L;

	private int id;
	private String NOM;
	private int COLLITA;
	private String CATEGORIA;
	private String CELLER;
	private String TIPUS;
	private String DESCRIPCIO;
	private float PREU;
	
	private Vi vi;
	private ProducteService viService = new ProducteServiceImpl();
	
	public addVi () {
	}
	
	public String add() {
		try {
			vi.setNOM(NOM);
			vi.setCOLLITA(COLLITA);
			vi.setCATEGORIA(getCATEGORIA());
			vi.setCELLER(CELLER);
			vi.setTIPUS(getTIPUS());
			vi.setDESCRIPCIO(DESCRIPCIO);
			vi.setPREU(PREU);
			viService.insertVi(vi);
			return SUCCESS;
		} catch (ConstraintViolationException e) {
			addActionError("Aquest vi no es pot afegir, ja es troba dins el sistema.");
			return INPUT;
		}
	}
	
	public String update() {
		try {
			vi = viService.getVi(getId());
			if (vi != null) {
				vi.setNOM(NOM);
				vi.setCOLLITA(COLLITA);
				vi.setCATEGORIA(getCATEGORIA());
				vi.setCELLER(CELLER);
				vi.setTIPUS(getTIPUS());
				vi.setDESCRIPCIO(DESCRIPCIO);
				vi.setPREU(PREU);
				viService.updateVi(vi);
			} 
		} catch (Exception e) {
				// Si la sesi ha caducat
			addActionError("No ha estat possible realitzar la modificaci.");
			return INPUT;
		}
		return SUCCESS;		
	}
	
	public Vi getVi() {
		return vi;
	}
	public void setVi(Vi vi) {
		this.vi = vi;
	}
	public void setId(int id) {
		this.id = id;
	}
	public int getId() {
		return id;
	}	
	public void setNOM(String NOM) {
		this.NOM = NOM;
	}	
	public String getNOM() {
		return NOM;
	}
	public void setCOLLITA(int cOLLITA) {
		COLLITA = cOLLITA;
	}
	public int getCOLLITA() {
		return COLLITA;
	}
	public void setCATEGORIA(String CATEGORIA) {
		this.CATEGORIA = CATEGORIA;
	}
	public String getCATEGORIA() {
		return CATEGORIA;
	}
	public void setCELLER(String cELLER) {
		CELLER = cELLER;
	}
	public String getCELLER() {
		return CELLER;
	}
	public void setTIPUS(String TIPUS) {
		this.TIPUS = TIPUS;
	}
	public String getTIPUS() {
		return TIPUS;
	}
	public void setDESCRIPCIO(String DESCRIPCIO) {
		this.DESCRIPCIO = DESCRIPCIO;
	}
	public String getDESCRIPCIO() {
		return DESCRIPCIO;
	}
	public void setPREU(float PREU) {
		this.PREU = PREU;
	}
	public float getPREU() {
		return PREU;
	}

}
