package model.dao;

import model.vo.Client;
import model.vo.Provincia;

import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

public class ClientHibernateDao implements ClientDao{
	
	private List<Client> clientList;
	private Client client;
	
	public void addClient(Client client) {
		Session session = HibernateUtil.getSessionFactory().openSession();
		Transaction tx=null;
		try {
			tx = session.beginTransaction();
			session.save(client);
			tx.commit();
		} catch (RuntimeException e) {
			if(tx != null) tx.rollback();
			throw e;
		} finally {
			session.close();
		}
	}

	public void updateClient(Client client) {
		Session session = HibernateUtil.getSessionFactory().openSession();
		Transaction tx = null;
		try {
			tx=session.beginTransaction();
			session.update(client);
			tx.commit();
		}catch (RuntimeException e) {
			if(tx != null) tx.rollback();
			throw e;
		} finally {
			session.close();
		}
	}
	
	public void deleteClient(String username) {
		Session session = HibernateUtil.getSessionFactory().openSession();
		Transaction tx = null;
		try {
			tx = session.beginTransaction();
			client = (Client)session.get(Client.class, username);
			session.delete(client);
			tx.commit();
		} catch (RuntimeException e) {
			if(tx != null) tx.rollback();
			throw e;
		} finally {
		    session.close();
		} 
	}

	public Client getClient(String username) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		try {
			session.beginTransaction();
			Query q = session.createQuery("from Client where username =:username");
			q.setString("username", username);
			return (Client) q.uniqueResult();
		}finally {
			session.close();
		}
	}
	
	@SuppressWarnings("unchecked")
	public List<Client> getClientByCognom1(String COGNOM1) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		try {
			session.beginTransaction();
			Query query = session.createQuery("from Client where COGNOM1 =:COGNOM1");
			query.setParameter("COGNOM1", COGNOM1);
			clientList = query.list();
			return clientList;
		} finally {
			session.close();
		}
	}

	@SuppressWarnings("unchecked")
	public List<Client> getClientByCognom2(String COGNOM2) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		try {
			session.beginTransaction();
			Query query = session.createQuery("from Client where COGNOM2 =:COGNOM2");
			query.setParameter("COGNOM2", COGNOM2);
			clientList = query.list();
			return clientList;
		} finally {
			session.close();
		}
	}

	@SuppressWarnings("unchecked")
	public List<Client> getClientByNom(String NOMBRE) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		try {
			session.beginTransaction();
			Query query = session.createQuery("from Client where NOM =:NOMBRE");
			query.setParameter("NOMBRE", NOMBRE);
			clientList = query.list();
			return clientList;
		} finally {
			session.close();
		}
	}

	@SuppressWarnings("unchecked")
	public List<Client> getAllClients() {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		try {
			session.beginTransaction();
			clientList = session.createQuery("from Client").list();
			return clientList;
		} finally {
			session.close();
		}
	}

	@SuppressWarnings("unchecked")
	public List<Provincia> getProvincies() {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
        List<Provincia> provincies = null;
        try {
            provincies = (List<Provincia>)session.createQuery("from Provincia").list();
         } catch (HibernateException e) {
            e.printStackTrace();
            session.getTransaction().rollback();
         } finally {
        	 session.close();
         }
		return provincies;
    } 
 
}
