package model.dao;

import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

import model.vo.Comanda;
import model.vo.LineaComanda;

public class ComandaHibernateDao implements ComandaDao {

	public Comanda getComanda(int idComanda) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		try {
			session.beginTransaction();
			Query q = session
					.createQuery("from Comanda where ID_COMANDA=:ID_COMANDA");
			q.setInteger("ID_COMANDA", idComanda);
			return (Comanda) q.uniqueResult();
		}finally {
			session.close();
		}
	}

	@SuppressWarnings("unchecked")
	public List<LineaComanda> getLineaComanda(Comanda Comanda) {
		Session session = HibernateUtil.getSessionFactory().openSession();
		session.beginTransaction();
		List<LineaComanda> linees = null;
        try {
	 
            Query query = session.createQuery(
            		"from LineaComanda where COMANDA =:COMANDA");
            query.setParameter("COMANDA", Comanda);
            linees = query.list();
        } catch (HibernateException e) {
            e.printStackTrace();
            session.getTransaction().rollback();
        } 
        session.getTransaction().commit();
        return linees;
	}

	@SuppressWarnings("unchecked")
	public List<Comanda> list() {
		Session session = HibernateUtil.getSessionFactory().openSession();
		session.beginTransaction();
		List<Comanda> comandes = null;
        try {
            comandes = (List<Comanda>)session
            	.createQuery("from Comanda").list();
        } catch (HibernateException e) {
            e.printStackTrace();
            session.getTransaction().rollback();
        }
        session.getTransaction().commit();
        return comandes;
	}

	public void insertComanda(Comanda comanda, List<LineaComanda> lineaList) {
		Session session = HibernateUtil.getSessionFactory().openSession();
		Transaction tx=null;
		int i;
		try {
			tx = session.beginTransaction();
			// Salvem la comanda
			session.save(comanda);
			// Salvem les linees de la comanda
			for(i=0;i<lineaList.size();i++) {
				LineaComanda linea = lineaList.get(i);
				session.save(linea);
			}
			tx.commit();
		} catch (RuntimeException e) {
			if(tx != null) tx.rollback();
			throw e;
		} finally {
			session.close();
		}
	}

	@SuppressWarnings("unchecked")
	public List<Comanda> listByClient(String username) {
		Session session = HibernateUtil.getSessionFactory().openSession();
		session.beginTransaction();
		List<Comanda> comandes = null;
        try {
	 
            Query query = session.createQuery(
            		"from Comanda where USERNAME =:username");
            query.setParameter("username", username);
            comandes = query.list();
        } catch (HibernateException e) {
            e.printStackTrace();
            session.getTransaction().rollback();
        } 
        session.getTransaction().commit();
        return comandes;
	}

	
}
