package model.dao;

import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.classic.Session;

import model.dao.HibernateUtil;
import model.vo.Provincia;

public class ProvinciaHibernateDao extends HibernateUtil implements ProvinciaDao {

	public Provincia add(Provincia provincia) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
	    session.beginTransaction();
	    session.save(provincia);
	    session.getTransaction().commit();
	    return provincia;
	}

	public Provincia delete(int id) {
	    Session session = HibernateUtil.getSessionFactory().getCurrentSession();
	    session.beginTransaction();
	    Provincia provincia = (Provincia) session.load(Provincia.class, id);
	    if(null != provincia) {
	    	session.delete(provincia);
	    }
	    session.getTransaction().commit();
	    return provincia;
	}

	@SuppressWarnings("unchecked")
	public List<Provincia> list() {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
        List<Provincia> provincies = null;
        try {
	 
            provincies = (List<Provincia>)session
            	.createQuery("from Provincia").list();
 
        } catch (HibernateException e) {
            e.printStackTrace();
            session.getTransaction().rollback();
        }
        session.getTransaction().commit();
        return provincies;
	}

	public Provincia getProvincia(int id) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		try {
			session.beginTransaction();
			Query q = session
					.createQuery("from Provincia where ID =:ID");
			q.setInteger("ID", id);
			return (Provincia) q.uniqueResult();
		}finally {
			session.close();
		}
	}

}
