package model.exception;

import model.exception.ClientException;

public class UsernameNotExistException extends ClientException {

	private static final long serialVersionUID = -7104556615367379759L;
	
	private String username;

	/**
	 * Constructor with non-existing username.
	 * 
	 * @param newUserName the non-existing username
	 */
	public UsernameNotExistException(String newUsername) {
		super("L'usuari " + newUsername + " no existeix al sistema.");
		this.username = newUsername;
	}
	
	public String getUsername() {
		return this.username;
	}
}
