package model.service;

import java.util.ArrayList;
import java.util.List;

public class Cistell {

	private ArrayList<CistellProducte> productes;
	
	public Cistell() {
		productes = new ArrayList<CistellProducte>();
	}
	
    public void addProducto(CistellProducte newProducto)
    {
        // Mirem si el producte s al cistell.
        // Si ya hi es, simplement incrementem la quantitat.
        CistellProducte cartProducto = findProducto(Integer.toString(newProducto.getId()));

        if (cartProducto != null)
        {
            cartProducto.setQuantity(cartProducto.getQuantity() + newProducto.getQuantity());
        }
        else
        {
            // Es un producte que no hi era; l'afegim al cistell.
            productes.add(newProducto);
        }
    }

    // Afegim una llista de productes.
    public void setProductos(List<CistellProducte> otherProductos)
    {
        productes.addAll(otherProductos);
    }

    public void setSize(int size){
    	
    }

    public int getSize()
    {
        return productes.size();
    }

    public void empty()
    {
        productes.clear();
    }

    public float getTotalPrice()
    {
        float total = 0;
        int size = productes.size();

        for (int i = 0;i < size;i++)
        {
            total += ((CistellProducte)productes.get(i)).getImporte();
        }
        // Preu total amb dos decimals
        int numero= (int)(total*100);
        total = (float) (numero/100.0);
        return total;
    }

    public void removeProducte(String productoId)
    {
        CistellProducte producto = findProducto(productoId);

        if (producto != null)
        {
            productes.remove(producto);
        }
    }

    public void updateQuantity(String productoId, int newQty)
    {
        CistellProducte producto = findProducto(productoId);

        if (producto != null)
        {
            producto.setQuantity(newQty);
        }
    }

    public List<CistellProducte> getProductos()
    {
        return productes;
    }

    private CistellProducte findProducto(String producteId)
    {
        CistellProducte producte = null;
        int size = getSize();

        for (int i = 0;i < size;i++)
        {
            CistellProducte cartProducto = (CistellProducte)productes.get(i);

            if (producteId.equals(Integer.toString(cartProducto.getId())))
            {
                producte = cartProducto;
                break;
            }
        }
        return producte;
    }
	
	
}
