package model.service;

import model.vo.Vi;

public class CistellProducte {

	private float importe = 0;
	private Vi producte = null;
	private int quantity = 1;


	public CistellProducte(Vi producte, int quantitat)
	{
		this.producte = producte;
		this.quantity = quantitat;
		calculaImport();
	}
	
	public void setProducte(Vi producte) {
		this.producte = producte;
		calculaImport();
	}
	
	private void calculaImport()
	{
		if (producte.getPREU() != 0)
		{
			setImporte(producte.getPREU() * getQuantity());
		}
	}

	public int getId() {
		return producte.getId();
	}
	
	public String getNOM() {
		return producte.getNOM();
	}
	
	public float getPREU() {
		return producte.getPREU();
	}
	
	public void setImporte(float importe) {
        // Import amb dos decimals
        int numero= (int)(importe*100);
        importe = (float) (numero/100.0);
		this.importe = importe;
	}

	public float getImporte() {
		return importe;
	}
	
	public int getQuantity() {
		return quantity;
	}

	public void setQuantity(int quantitat) {
		this.quantity = quantitat;
		calculaImport();
	}
	
}
