package model.service;

import java.util.List;

import model.exception.ClientException;
import model.vo.Client;
import model.vo.Provincia;

public interface ClientService {
	
	/** Cas d's 5. INICIAR SESSIO.				 
	 * @throws ClientException 
	 * 
	 * */
	public Client login(String username, String password) throws ClientException;

	/** Cas d's 15. ALTA CLIENT.	 
	 * 
	 * */
	public void insertClient(Client client);
		
	/** Cas d's 16. CONSULTAR CLIENT.	 
	 * 
	 * */
	public Client loadClient(String username);
		
	/** Cas d's 17. BAIXA CLIENT.	 
	 *
	 * */
	public void deleteClient(String username);
	
	/** Cas d's 18. MODIFICAR CLIENT.	 
	 *
	 * */
	public void updateClient(Client client);

	public List<Provincia> getProvincies();
	public List<Client> getAllClients();
	public List<Client> getClientByNom(String NOM);
	public List<Client> getClientByCognom1(String COGNOM1);
	public List<Client> getClientByCognom2(String COGNOM2);
	
}
