package model.service;

import java.util.List;

import org.hibernate.HibernateException;

import model.dao.ClientDao;
import model.dao.ClientHibernateDao;
import model.exception.ClientException;
import model.exception.UsernameNotExistException;
import model.vo.Client;
import model.vo.Provincia;

public class ClientServiceImpl implements ClientService {
	
	private ClientDao dao;
	
	public ClientServiceImpl(){
		this.dao = new ClientHibernateDao();
	}
	
	public void deleteClient(String username) {
		dao.deleteClient(username);
	}
	
	public List<Provincia> getProvincies() {
		return dao.getProvincies();
	}

	public List<Client> getAllClients() {
		return dao.getAllClients();
	}

	public List<Client> getClientByCognom1(String COGNOM1) {
		return dao.getClientByCognom1(COGNOM1);
	}

	public List<Client> getClientByCognom2(String COGNOM2) {
		return dao.getClientByCognom2(COGNOM2);
	}

	public List<Client> getClientByNom(String NOM) {
		return dao.getClientByNom(NOM);
	}

	public void insertClient(Client client) {
		dao.addClient(client);
	}

	public Client loadClient(String username) {
		return dao.getClient(username);
	}

	public Client login(String username, String password) throws ClientException {
		try {
			Client client = this.dao.getClient(username);		
			if (client != null) {
				if (!client.getPASSWORD().equals(password)) {
					client = null;
				}
			}
			return client;
		} catch (HibernateException he) {
			//usuari no existeix
			throw new UsernameNotExistException(username);
		} catch (Exception e) {
			throw new ClientException("Could not login", e);
		}
	}

	public void updateClient(Client client) {
		dao.updateClient(client);
	}

	public ClientDao getClientDao() {
		return dao;
	}

	public void setClientDao(ClientDao dao) {
		this.dao = dao;
	}
	
}
