package model.service;

import java.util.List;

import model.dao.ComandaDao;
import model.dao.ComandaHibernateDao;
import model.vo.Comanda;
import model.vo.LineaComanda;

public class ComandaServiceImpl implements ComandaService {

	private ComandaDao dao;
	
	public ComandaServiceImpl() {
		this.dao = new ComandaHibernateDao();
	}

	public void addComanda(Comanda comanda, List<LineaComanda> lineaList) {
		dao.insertComanda(comanda, lineaList);
	}

	public List<Comanda> getAllComandes() {
		return dao.list();
	}

	public Comanda loadComanda(int ID_COMANDA) {
		return dao.getComanda(ID_COMANDA);
	}

	public List<LineaComanda> loadLineaComanda(Comanda COMANDA) {
		return dao.getLineaComanda(COMANDA);
	}

	public List<Comanda> getComandesByClient(String username) {
		return dao.listByClient(username);
	}

}
