package model.service;

import java.util.List;

import model.dao.ProducteDao;
import model.dao.ProducteHibernateDao;
import model.vo.Denominacio;
import model.vo.Vi;

public class ProducteServiceImpl implements ProducteService{

	private ProducteDao dao;
	
	public ProducteServiceImpl(){
		this.dao = new ProducteHibernateDao();
	}
	
	public List<Denominacio> list() {
		return dao.list();
	}

	public List<Vi> getVinsByDenominacio(int id_DENOMINACIO) {
		return dao.getProductsByDenominacio(id_DENOMINACIO);
	}

	public Denominacio loadDenominacio(int id_DENOMINACIO) {
		return dao.getDenominacio(id_DENOMINACIO);
	}

	public void insertDenominacio(Denominacio denominacio) {
		dao.addDenominacio(denominacio);
	}

	public void updateDenominacio(Denominacio denominacio) {
		dao.updateDenominacio(denominacio);
	}
	
	public void deleteDenominacio(int id_DENOMINACIO) {
		dao.deleteDenominacio(id_DENOMINACIO);
	}
	
	public void insertVi(Vi vi) {
		dao.addVi(vi);
	}

	public Vi getVi(int idVI) {
		return dao.getVi(idVI);
	}

	public List<Vi> getVinsByCategoria(String CATEGORIA) {
		return dao.getProductsByCategoria(CATEGORIA);
	}

	public List<Vi> getVinsByNom(String NOM) {
		return dao.getProductsByNom(NOM);
	}

	public List<Vi> getVinsByTipus(String TIPUS) {
		return dao.getProductsByTipus(TIPUS);
	}

	public List<Vi> getAllVins() {
		return dao.getAllProducts();
	}

	public void updateVi(Vi vi) {
		dao.updateVi(vi);
	}

	public void deleteVi(int idVI) {
		dao.deleteVi(idVI);	
	}

	public List<Vi> getVinsByCriteria(String find, String TIPUS, 
			String CATEGORIA, boolean description) {
		return dao.getProductsByCriteria(find, TIPUS, CATEGORIA, description);
	}

}
